#include <stdint.h>

#include "LDChip.h"
#include "stm32f10x.h"
#include "stm32f10x_conf.h"

#include "stm32f10x_spi.h"

#include "ff.h"
#include "ffconf.h"
#include "diskio.h"
#include "fatfs_posix.h"

#include "AsrItem.h"


/*************˿Ϣ********************
 * ˵
 * RST      PB6
 * CS   	PB8
 * WR/SPIS  PB9
 * P2/SDCK  PB3
 * P1/SDO   PB4
 * P0/SDI   PB5
 * IRQ      PC1
 * A0				PB7
 * RD       PA0
*****************************************/

#define CS_H()	GPIO_SetBits(GPIOB, GPIO_Pin_8)
#define CS_L()	GPIO_ResetBits(GPIOB, GPIO_Pin_8)

#define SPIS_H()  GPIO_SetBits(GPIOB, GPIO_Pin_9)
#define SPIS_L()  GPIO_ResetBits(GPIOB, GPIO_Pin_9)

#define RST_H() GPIO_SetBits(GPIOB, GPIO_Pin_6)
#define RST_L() GPIO_ResetBits(GPIOB, GPIO_Pin_6)


uint32 nMp3Size=0;				   //mp3ļĴС
uint32 nMp3Pos=0;				   //mp3ļƫ(ƫƾļС)
uint8  nLD_Mode = LD_MODE_IDLE;	   //¼ǰڽASRʶڲMP3
uint8  bMp3Play=0;				   //¼MP3״̬


void delay_ms(unsigned long uldata)
{
	unsigned int i;
	uint8 j;
	for (i=uldata*100;i>0;i--);
		for (j=110;j>0;j--);
}


uint8 nAsrStatus = 0;

static uint8 spi_send_byte(uint8 byte)
{
	/* ѭⷢͻǷǿ */
	while (SPI_I2S_GetFlagStatus(SPI3, SPI_I2S_FLAG_TXE) == RESET);

	/*ͨSPI3跢*/
	SPI_I2S_SendData(SPI3,byte);

	/* ȴݣѭݻ */
	while (SPI_I2S_GetFlagStatus(SPI3,SPI_I2S_FLAG_RXNE) == RESET);

	/* ض */
	return SPI_I2S_ReceiveData(SPI3);
}

//дld3320Ĵ
void ld3320_write_reg(uint8 data1,uint8 data2)
{
	CS_L();

	SPIS_L();

	spi_send_byte(0x04);

	spi_send_byte(data1);

	spi_send_byte(data2);

	CS_H();

}

//ld3320Ĵ
uint8 ld3320_read_reg(uint8 reg_add)
{
	uint8 i;

	CS_L();
	SPIS_L();

	spi_send_byte(0x05);

	spi_send_byte(reg_add);

	i=spi_send_byte(0);

	CS_H();

	return(i);
}

void ld3320_nvic_cfg(void)
{
  EXTI_InitTypeDef EXTI_InitStructure;
	NVIC_InitTypeDef NVIC_InitStructure;
  GPIO_InitTypeDef GPIO_InitStructure;

  //ж
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOC, ENABLE);
  GPIO_InitStructure.GPIO_Pin =GPIO_Pin_1;
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOC, &GPIO_InitStructure);
	//ⲿж
  GPIO_EXTILineConfig(GPIO_PortSourceGPIOC, GPIO_PinSource1);
  EXTI_InitStructure.EXTI_Line = EXTI_Line1;
  EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
  EXTI_InitStructure.EXTI_Trigger =EXTI_Trigger_Falling;
  EXTI_InitStructure.EXTI_LineCmd = ENABLE;
  EXTI_Init(&EXTI_InitStructure);
  EXTI_GenerateSWInterrupt(EXTI_Line1);
		
	GPIO_SetBits(GPIOC,GPIO_Pin_1);	 //Ĭж

	EXTI_ClearFlag(EXTI_Line1);
	EXTI_ClearITPendingBit(EXTI_Line1);
	//жǶ
  NVIC_InitStructure.NVIC_IRQChannel = EXTI1_IRQn;
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
  NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
  NVIC_Init(&NVIC_InitStructure);
}



void ld3320_spi_init(void)
{
	SPI_InitTypeDef  SPI_InitStructure;
	GPIO_InitTypeDef GPIO_InitStructure;
  //spi˿
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_SPI3 | RCC_APB2Periph_GPIOB,ENABLE);	   //ʹSPI3ʱ
  GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable, ENABLE); 

	//P0/P1/P2
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5 | GPIO_Pin_4 | GPIO_Pin_3;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOB,&GPIO_InitStructure);
	//spis Ƭѡ	WR
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;			
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIOB, &GPIO_InitStructure);
  
	CS_H();
	
	//spi
	SPI_Cmd(SPI3, DISABLE);
	/* SPI3  */
	SPI_InitStructure.SPI_Direction = SPI_Direction_2Lines_FullDuplex;   //ȫ˫
	SPI_InitStructure.SPI_Mode = SPI_Mode_Master;						   //ģʽ
	SPI_InitStructure.SPI_DataSize = SPI_DataSize_8b;					   //8λ
	SPI_InitStructure.SPI_CPOL = SPI_CPOL_High;						   //ʱӼ ״̬ʱSCKֵ͵ƽ
	SPI_InitStructure.SPI_CPHA = SPI_CPHA_1Edge;						   //ʱλ ݲӵһʱӱؿʼ
	SPI_InitStructure.SPI_NSS = SPI_NSS_Soft;							   //NSS
	SPI_InitStructure.SPI_BaudRatePrescaler = SPI_BaudRatePrescaler_128;   //ʿ SYSCLK/128
	SPI_InitStructure.SPI_FirstBit = SPI_FirstBit_MSB;				   //ݸλǰ
	SPI_InitStructure.SPI_CRCPolynomial = 7;							   //CRCʽĴʼֵΪ7
	SPI_Init(SPI3, &SPI_InitStructure);
	/* ʹSPI3 */
	SPI_Cmd(SPI3, ENABLE);
}


uint8 spi_read_byte(void)
{
	return (spi_send_byte(0));
}


void ld3320_gpio_configuration(void)
{

	GPIO_InitTypeDef GPIO_InitStructure;

	RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA | RCC_APB2Periph_GPIOB |
	                        RCC_APB2Periph_GPIOC | RCC_APB2Periph_GPIOD ,ENABLE);
		//LD_CS/A0/RSET
		GPIO_InitStructure.GPIO_Pin =GPIO_Pin_8|GPIO_Pin_7|GPIO_Pin_6;//;
		GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
		GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
		GPIO_Init(GPIOB,&GPIO_InitStructure);
	 	GPIO_SetBits(GPIOB,GPIO_Pin_7);	/*A0Ĭ*/
}


void LD_reset(void)	  //оƬλ
{
	RST_H();
	delay_ms(100);
	RST_L();
	delay_ms(100);
  RST_H();
	delay_ms(100);
	CS_L();
	delay_ms(100);
	CS_H();
	delay_ms(100);
}

/************************************************************************************************************/

void LD_Init_Common(void)	//ͨóʼ
{

	ld3320_read_reg(0x06);
	ld3320_write_reg(0x17, 0x35); //λLD3320
	delay_ms(100);
	ld3320_read_reg(0x06);

	ld3320_write_reg(0x89, 0x03);  //ģ· ʼʱд03H
	delay_ms(50);
	ld3320_write_reg(0xCF, 0x43);  //ڲʡģʽ ʼʱд43H
	delay_ms(50);
	ld3320_write_reg(0xCB, 0x02);

	/*PLL setting*/
	ld3320_write_reg(0x11, LD_PLL_11);   //ʱƵ1
	if (nLD_Mode == LD_MODE_MP3)   //MP3
	{
		ld3320_write_reg(0x1E, 0x00); 	//ADCרÿƣӦʼΪ00H
		ld3320_write_reg(0x19, LD_PLL_MP3_19);   //ʱƵ2
		ld3320_write_reg(0x1B, LD_PLL_MP3_1B);   //ʱƵ3
		ld3320_write_reg(0x1D, LD_PLL_MP3_1D);	//ʱƵ4
	}
	else						   //ʶ
	{
		ld3320_write_reg(0x1E,0x00);	   //ADCרÿƣӦʼΪ00H
		ld3320_write_reg(0x19, LD_PLL_ASR_19); 	 //ʱƵ2
		ld3320_write_reg(0x1B, LD_PLL_ASR_1B);	 //ʱƵ3
		ld3320_write_reg(0x1D, LD_PLL_ASR_1D);	 //ʱƵ4
	}
	delay_ms(100);

	ld3320_write_reg(0xCD, 0x04);	 //DSP ʼʱд04H DSP
	ld3320_write_reg(0x17, 0x4C); 	 //д4CHʹDSPߣȽʡ
	delay_ms(50);
	ld3320_write_reg(0xB9, 0x00);	 //ASRǰʶַȣƴַʼʱд00H	 ÿһʶҪ趨һ
	ld3320_write_reg(0xCF, 0x4F); 	 //ڲʡģʽ MP3ʼASRʼʱд 4FH
	ld3320_write_reg(0x6F, 0xFF); 	 //оƬгʼʱΪ0xFF
}

uint8 RunASR(void)
{
	uint8 i=0;
	uint8 j;
	uint8 asrflag=0;
	for (i=0; i<5; i++)			//	ֹӲԭLD3320оƬһ5ASRʶ
	{
		LD_AsrStart();
		delay_ms(100);
		if (LD_AsrAddFixed()==0)
		{
			LD_reset();			//	LD3320оƬڲֲLD3320оƬ
			delay_ms(100);			//	ӳʼʼASRʶ
			continue;
		}
		LD_TEST();
		delay_ms(100);
		j= LD_AsrRun();
		if (j == 0)
		{
			LD_reset();			//	LD3320оƬڲֲLD3320оƬ
			delay_ms(100);			//	ӳʼʼASRʶ
			continue;
		}

		asrflag=1;
		break;					//	ASRɹ˳ǰforѭʼȴLD3320ͳжź
	}

	return asrflag;
}


void LD_Init_MP3(void)	//ųʼ
{
	nLD_Mode = LD_MODE_MP3;	   //ǰMP3
	LD_Init_Common();		   //ͨóʼ

	ld3320_write_reg(0xBD,0x02);	   //ڲ ʼʱдFFH
	ld3320_write_reg(0x17, 0x48);	//д48HԼDSP
	delay_ms(100);

	ld3320_write_reg(0x85, 0x52); 	//ڲ ʼʱд52H
	ld3320_write_reg(0x8F, 0x00);  	//LineOut(·)ѡ ʼʱд00H
	ld3320_write_reg(0x81, 0x00);	// Ϊ00HΪ
	ld3320_write_reg(0x83, 0x00);	// Ϊ00HΪ
	ld3320_write_reg(0x8E, 0xff);	//  ĴΪ00HΪ	˴ر
	ld3320_write_reg(0x8D, 0xff);	//ڲ ʼʱдFFH
	delay_ms(100);
	ld3320_write_reg(0x87, 0xff);	//ģ· MP3ųʼʱд FFH
	ld3320_write_reg(0x89, 0xff);   //ģ· MP3ʱд FFH
	delay_ms(100);
	ld3320_write_reg(0x22, 0x00);   //FIFO_DATA޵8λ
	ld3320_write_reg(0x23, 0x00);	//FIFO_DATA޸8λ
	ld3320_write_reg(0x20, 0xef);   //FIFO_DATA޵8λ
	ld3320_write_reg(0x21, 0x07);	//FIFO_DATA޸8λ
	ld3320_write_reg(0x24, 0x77);    
	ld3320_write_reg(0x25, 0x03);	
	ld3320_write_reg(0x26, 0xbb);    
	ld3320_write_reg(0x27, 0x01); 	
}

/* ʶʼ */
void LD_Init_ASR(void)	   
{
	nLD_Mode=LD_MODE_ASR_RUN;	     //ǰʶ
	LD_Init_Common();	   			 //ͨóʼ

	ld3320_write_reg(0xBD, 0x00);	 //
	ld3320_write_reg(0x17, 0x48);	 //д48HԼDSP
	delay_ms( 100 );

	ld3320_write_reg(0x3C, 0x80);
	ld3320_write_reg(0x3E, 0x07);
	ld3320_write_reg(0x38, 0xff);
	ld3320_write_reg(0x3A, 0x07);
 	delay_ms( 100 );

	ld3320_write_reg(0x40, 0);
	ld3320_write_reg(0x42, 8);
	ld3320_write_reg(0x44, 0);
	ld3320_write_reg(0x46, 8);
	delay_ms( 100 );
}


//mp3׼
void LD_play()	 
{
	nMp3Pos=0;
	bMp3Play=1;

	if (nMp3Pos >=  nMp3Size)
		return ; 

	fill_the_fifo();
//	LD_ReloadMp3Data();

    ld3320_write_reg(0xBA, 0x00);
	ld3320_write_reg(0x17, 0x48);
	ld3320_write_reg(0x33, 0x01);
	ld3320_write_reg(0x29, 0x04);
	
	ld3320_write_reg(0x02, 0x01); 
	ld3320_write_reg(0x85, 0x5A);

}

//
void LD_AdjustMIX2SPVolume(uint8 val)	  
{
	val = ((15-val)&0x0f) << 2;		  //
	ld3320_write_reg(0x8E, val | 0xc3);
	ld3320_write_reg(0x87, 0x78);
}


//fifoӶfifoж,Ϊmp3׼
void fill_the_fifo(void)
{
    uint8 ucStatus;
	int i = 0;
	ucStatus = ld3320_read_reg(0x06);
	//fifoǷ
	while ( !(ucStatus&MASK_FIFO_STATUS_AFULL))
	{

		ld3320_write_reg(0x01,0xff);
		i++;
		ucStatus = ld3320_read_reg(0x06);
	}
	
}

//оƬڲ޳
// Return 1: success.
uint8 LD_Check_ASRBusyFlag_b2()	   
{
	uint8 j;
	uint8 flag = 0;
	for (j=0; j<10; j++)
	{
		if (ld3320_read_reg(0xb2) == 0x21)
		{
			flag = 1;
			break;
		}
		delay_ms(10);
	}
	return flag;
}

void LD_AsrStart()		
{
	LD_Init_ASR();
}

// Return 1: success.
uint8 LD_AsrRun()		//ʼʶ
{

	ld3320_write_reg(0x35, MIC_VOL);//˷
	ld3320_write_reg(0xB3, 0xf);    //


	ld3320_write_reg(0x1C, 0x09);	//ADCؿ д09H Reserve
	ld3320_write_reg(0xBD, 0x20);	//ʼƼĴ д20HReserve
	ld3320_write_reg(0x08, 0x01);	//FIFOݵ0λд1FIFO_DATA 2λд1FIFO_EXT
	delay_ms( 1 );
	ld3320_write_reg(0x08, 0x00);	//FIFOݵ0λָFIFOдһ00H
	delay_ms( 1 );

	if (LD_Check_ASRBusyFlag_b2() == 0)	  //оƬڲ
	{
		return 0;
	}

	ld3320_write_reg(0xB2, 0xff);	  //ASRDSPæ״̬ 0x21 ʾУѯΪ״̬Խһ ??? Ϊʲôread??
	ld3320_write_reg(0x37, 0x06);	  //ʶ·Ĵ д06H ֪ͨDSPʼʶ ·ǰҪB2Ĵ
	delay_ms( 5 );
	LD_TEST();
	ld3320_write_reg(0x1C, 0x0b);	  // ADCؿ  д0BH ˷ADCͨ
	ld3320_write_reg(0x29, 0x10);	  //ж 2λFIFO ж 4λͬж 10

	ld3320_write_reg(0xBD, 0x00);	  //ʼƼĴ д00 Ȼ ΪASRģ


	return 1;
}

void LD_AsrAddFixed_ByString(char * pRecogString, uint8 k)
{
	uint8 nAsrAddLength;

	if (*pRecogString==0)
		return;

	ld3320_write_reg(0xc1, k );	   //ASRʶIndex00HFFH
	ld3320_write_reg(0xc3, 0 );	   //ASRʶʱд00
	ld3320_write_reg(0x08, 0x04);	 //FIFOݵ0λд1FIFO_DATA 2λд1FIFO_EXT
	delay_ms(1);
	ld3320_write_reg(0x08, 0x00);	 //FIFOݵ0λָFIFOдһ00H
	delay_ms(1);

	for (nAsrAddLength=0; nAsrAddLength<50; nAsrAddLength++)
	{
		if (pRecogString[nAsrAddLength] == 0)
			break;
		ld3320_write_reg(0x5, pRecogString[nAsrAddLength]);	  //дFIFO_EXTݿ
	}

	ld3320_write_reg(0xb9, nAsrAddLength);	  //ǰʶַȳʼʱд00H ÿһʶҪ趨һ
	ld3320_write_reg(0xb2, 0xff);	  //DSPæ״̬ 0x21 ʾ Խһ	   ??
	ld3320_write_reg(0x37, 0x04);	  //ʶ·Ĵ д04H֪ͨDSPҪһʶ
}


uint8 LD_GetResult()
{
	uint8 res;

	res = ld3320_read_reg(0xc5);

	return res;
}


void LD_TEST(void)
{
// ld3320_write_reg(0x35, 0x22);
// ld3320_write_reg(0x1b, 0x44);
// ld3320_write_reg(0xb3, 0x66);
// ld3320_read_reg(0xBF);
// ld3320_read_reg(0x06);
// ld3320_read_reg(0x35);
// ld3320_read_reg(0xb3);
//
}


/*******************************************************************************************************************/
static	int fd;
void LD_ReloadMp3Data_Again(void);


#include "get_item.h"

// Return 1: success.
//	ʶؼ߿ѧϰ"ʶоƬLD3320߽ؼ.pdf"йմ÷
uint8 LD_AsrAddFixed(void)	  //ӹؼﵽLD3320оƬ
{
	return add_item_from_ini(ini_file_name);
}


uint8 ucRegVal;	  //Ĵݱ
uint8 ucHighInt;  //Ĵݱ
uint8 ucLowInt;	  //Ĵݱ

void ProcessInt0(void)	  // ʶж
{
	uint8 nAsrResCount=0;

	ucRegVal = ld3320_read_reg(0x2B);

	if (nLD_Mode == LD_MODE_ASR_RUN)		//ǰʶ
	{
		// ʶж
		// 룬ʶɹʧܶжϣ
		ld3320_write_reg(0x29,0) ;				     //ж FIFO ж 0ʾ
		ld3320_write_reg(0x02,0) ;		             // FIFOж	 FIFO_DATA FIFO_EXTж   
		if ((ucRegVal & 0x10) &&		             //2bλΪ1 оƬڲFIFOжϷ MP3ʱжϱ־ⲿMCUFIFO_DATAReload
		     ld3320_read_reg(0xb2)==0x21 && 	     //b2õ0x21ʾпԽһASR
		     ld3320_read_reg(0xbf)==0x35)		     //ֵΪ0x35ȷһʶ
		{
			nAsrResCount = ld3320_read_reg(0xba);    //ASRжʱжʶмʶѡ
			if (nAsrResCount==1)
			{
				ld3320_read_reg(0xc5);
			}
			if (nAsrResCount>0 && nAsrResCount<=4) 	 //1 C 4: Nʶѡ 0ߴ4ûʶѡ
			{
				nAsrStatus=LD_ASR_FOUNDOK;		     //ʾһʶ̽һʶ
			}
			else
			{
				nAsrStatus=LD_ASR_FOUNDZERO;	     //ʾһʶ̽ûʶ
			}
		}
		else
		{
			nAsrStatus=LD_ASR_FOUNDZERO;	         //ʾһʶ̽ûʶ
		}

		ld3320_write_reg(0x2b, 0);
		ld3320_write_reg(0x1C,0);	  				 //ADCؿ д00H ADC
		return;
	}

	// Ųжϣ֣
	// A. ȫꡣ
	// B. ѷϡ
	// C. ʱҪ꣬Ҫµݡ	
	ucHighInt = ld3320_read_reg(0x29); 
	ucLowInt=ld3320_read_reg(0x02); 
	ld3320_write_reg(0x29,0) ;
	ld3320_write_reg(0x02,0) ;
    if(ld3320_read_reg(0xBA)&CAUSE_MP3_SONG_END)
    {
	// A. ȫꡣ

		ld3320_write_reg(0x2B,  0);
      	ld3320_write_reg(0xBA, 0);	
		ld3320_write_reg(0xBC,0x0);	
		bMp3Play=0;					// ȫ޸bMp3Playı
		ld3320_write_reg(0x08,1);

      	ld3320_write_reg(0x08,0);
		ld3320_write_reg(0x33, 0);
		close(fd);
		return ;
     }

	if(nMp3Pos>=nMp3Size)
	{
	// B. ѷϡ

		ld3320_write_reg(0xBC, 0x01);
		ld3320_write_reg(0x29, 0x10);
		close(fd);
		return;	
	}

	// C. ʱҪ꣬Ҫµݡ	

	LD_ReloadMp3Data_Again();
			
	ld3320_write_reg(0x29,ucHighInt); 
	ld3320_write_reg(0x02,ucLowInt) ;

}

   
/*  ȡmp3ļݵfifo,ֱfifo
 *	дmp3ļݵfifoʱ,LD3320벥
 *	Ȼдmp3ļݵfifoʱ̹ʱ
 *	첥ϵʱProcessInt0
 *	ProcessInt0ֻô˺,
 */
void LD_ReloadMp3Data_Again(void)
{
	uint8 val;
    uint8 ucStatus;

	ucStatus = ld3320_read_reg(0x06);
	//fifoǷ
	while (!(ucStatus&MASK_FIFO_STATUS_AFULL) && nMp3Pos<=nMp3Size)
	{

		nMp3Pos++;
		read(fd,&val,1);

		ld3320_write_reg(0x01,val);

		ucStatus = ld3320_read_reg(0x06);
	}

	if(nMp3Pos>=nMp3Size)
	{
	    ld3320_write_reg(0xBC, 0x01);
		ld3320_write_reg(0x29, 0x10);

		//ȴMP3
		while(!(ld3320_read_reg(0xBA)&CAUSE_MP3_SONG_END));

		ld3320_write_reg(0x2B,  0);
      	ld3320_write_reg(0xBA, 0);	
		ld3320_write_reg(0xBC,0x0);	
		bMp3Play=0;					// ȫ޸bMp3Playı
		ld3320_write_reg(0x08,1);

      	ld3320_write_reg(0x08,0);
		ld3320_write_reg(0x33, 0);

		close(fd);

	}
		
}

/*
 * mp3ʱô˺
 */
int PlayDemoSound_mp3(char *path)
{

	fd = open(path,0,0);
	if(fd == -1)
	{
	   close(fd);
	   return fd;
	}

	bMp3Play = 1;

	nMp3Size = get_file_size(fd)-1;

	//LD3320ʼΪMP3ģʽ
	LD_Init_MP3();
	//ö
	LD_AdjustMIX2SPVolume(7);
	//ʼ
	LD_play();

    return 0;

}

