#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#include "stm32f10x.h"
#include "sdio_sdcard.h"

#include "ff.h"
#include "ffconf.h"
#include "diskio.h"
#include "fatfs_posix.h"

#include "idle.h"
#include "LDchip.h"
#include "get_item.h"
#include "stm32f10x_usart.h"
#include "user_key.h"

void  USART_Configuration(void);
extern uint8 nAsrStatus;

int main(void)
{
static uint8_t Init_flag=0;
uint8_t SD_ok_flag=0;
	USART_Configuration();
	User_key_init();	 /*û̳ʼ*/

	{	/* PA8 	 8M  */
	    GPIO_InitTypeDef GPIO_InitStructure;
	
	    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_AFIO, ENABLE);
	
	    /*    MCO    configure */
	    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;
	    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	    GPIO_Init(GPIOA,&GPIO_InitStructure);	
	    RCC_MCOConfig( RCC_MCO_HSE);		//8M
	}

	{
		FATFS fs;
		SD_CardInfo SDCardInfo;

		/* SDӿڳʼ	 */
		SD_ok_flag=SD_Init();
		/* ȡSDϢ */
		SD_GetCardInfo(&SDCardInfo);
		SD_SelectDeselect((uint32_t) (SDCardInfo.RCA << 16));
		/* SDIOӿݿ */
		SD_EnableWideBusOperation(SDIO_BusWide_4b);
		/* ùģʽ */
		SD_SetDeviceMode(SD_DMA_MODE);
		/* ļϵͳFATFS ʼ */
		disk_initialize(0);
		/* SDص0 */
		f_mount(0, &fs);
	}

	{	/* ld3320IOڳʼ       */
		ld3320_gpio_configuration();
		/* ld3320жϳʼ       */
		ld3320_nvic_cfg();
		/* ld3320Ŀƶ˳ʼ     */
		ld3320_spi_init();
		/* ld3320λ  */
		LD_reset();
		/* ʼ״̬ûASR    */
		nAsrStatus = LD_ASR_NONE;
		/* ld3320    */
		LD_TEST();
		bMp3Play=0;
	}
   

	while (1)
	{
	 idle();
	 if(Init_flag==0 && SD_ok_flag==SD_OK)
		{
			PlayDemoSound_mp3("sys_sound.mp3");
			Init_flag=1;
		}
		if (bMp3Play != 0)			//	ڲMP3УȴֱMP3 bMp3Play==0
			continue;				//	bMp3Play Ƕһȫֱ¼MP3ŵ״̬LD3320оƬڲļĴ
		
		switch (nAsrStatus)
		{
		case LD_ASR_RUNING:	   //  LD3320оƬʶ
			break;

		case LD_ASR_ERROR:	   //  LD3320оƬ
			break;

		case LD_ASR_NONE:	   //  LD3320оƬ޶
		{

			nAsrStatus=LD_ASR_RUNING;
			if (RunASR()==0)	//	һASRʶ̣ASRʼASRӹؼASR
			{
				nAsrStatus = LD_ASR_ERROR;
			}
			break;
		}
		case LD_ASR_FOUNDOK:	//  LD3320оƬʶ
		{

			char mp3_name[MP3_NAME_LEN];    //mp3ļ
			//
			int nAsrRes = LD_GetResult();	//	һASRʶ̽ȥȡASRʶ

			get_mp3_name(ini_file_name,nAsrRes,mp3_name);

			//ûʵԼĴ
			deal_the_index(nAsrRes);
			USART_SendData(USART1,nAsrRes);			 //ʶ 	 		
		  while(USART_GetFlagStatus(USART1, USART_FLAG_TC)==RESET);// ָUSART־λ
			//mp3
			PlayDemoSound_mp3(mp3_name);
			nAsrStatus = LD_ASR_NONE;
			break;
		}
		case LD_ASR_FOUNDZERO: //ʶ
			nAsrStatus = LD_ASR_NONE;
			break;
		default:
		{
			nAsrStatus = LD_ASR_NONE;
			break;
		}
		}
	}

}

/***********************************************************
*     ƣ
*     ܣ
* ڲ  
* ڲ
* ˵    
* ÷ 
**********************************************************/ 
//
void  USART_Configuration(void)
{
  GPIO_InitTypeDef GPIO_InitStructure;
  USART_InitTypeDef USART_InitStructure;	//USART_InitTypeDef͵Ľṹ
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1 | RCC_APB2Periph_GPIOA |RCC_APB2Periph_AFIO\
												  , ENABLE);

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;	         //USART1 TX
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;    //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOA, &GPIO_InitStructure);		    //A˿ 

  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;	         //USART1 RX
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;   //ÿ©
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA, &GPIO_InitStructure);		         //A˿ 
	 
  USART_InitStructure.USART_BaudRate = 9600;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_Mode =  USART_Mode_Tx;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;

  /* Configure USART1 */
  USART_Init(USART1, &USART_InitStructure);
//  USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);  //ʹܽ ж 
  USART_ITConfig(USART1, USART_IT_TXE, ENABLE);  //ʹܷ ж 
  USART_Cmd(USART1, ENABLE);
}
